#pragma once
#include <assert.h>

template <class T>
struct Array3D
{
	Array3D(){data = 0; clear();}
	Array3D(const Array3D<T> &a){data = 0; copy(a);}
	~Array3D(){clear();}

	T *data;
	int data_size;
	int s[3];

	void operator=(const Array3D<T> &a) {copy(a);}
	void copy(const Array3D<T> &a)
	{
		resize(a.s[0], a.s[1], a.s[2]);
		for (int i = 0; i < data_size; i++)
			data[i] = a.data[i];
	}

	void resize(int w, int h, int d)
	{
		clear();

		data_size = w*h*d;
		s[0] = w;
		s[1] = h;
		s[2] = d;

		data = new T[data_size];
	}
	template <class S> void resize(S p) {resize(p[0], p[1], p[2]);}

	T &operator()(int x, int y, int z)
	{
		return data[(z*s[1] + y)*s[0] + x];
	}

	template <class S>
	T &operator[](S p)
	{
		return data[(p[2]*s[1] + p[1])*s[0] + p[0]];
	}

	int index(int x, int y, int z)
	{
		return (z*s[1] + y)*s[0] + x;
	}
	template <class S> void index(S p) {index(p[0], p[1], p[2]);}

	void clear()
	{
		delete[] data;
		data = 0;
		s[0] = s[1] = s[2] = 0;
		data_size = 0;
	}

	bool empty(){return data_size == 0;}

	// math operators
	void operator=(const T &a)
	{
		for (int i = 0; i < data_size; i++)
			data[i] = a;
	}
};
